; barsunduk 10/2011
EnableExplicit

UsePNGImageDecoder()

;#ULW_ALPHA = 2
;#AC_SRC_ALPHA = 1

Structure TPoint
  x.l
  y.l
EndStructure

Structure TBlendFunction
  BlendOp.b
  BlendFlags.b
  SourceConstantAlpha.b
  AlphaFormat.b
EndStructure

Structure TArgb
  b.b
  g.b
  r.b
  a.b
EndStructure

Global Dim acol(256, 256)
Global xy.TPoint
Global dx = 0
Global dy = 0
Global Moving = #False

;   ,    
Procedure imgResize(hImg, newW, newH)
  Protected hImgNew = GrabImage(hImg, #PB_Any, 0, 0, ImageWidth(hImg), ImageHeight(hImg))
  ResizeImage(hImgNew, newW, newH, #PB_Image_Raw)
  ProcedureReturn hImgNew
EndProcedure

;     
;  ,   
;     ,  newW  newH = #PB_Ignore
; hBmp    (.. = #PB_Any),
;       ,
;    
Procedure png2bmp(hPng, hBmp, newW, newH)
  Protected w = ImageWidth(hPng)
  Protected h = ImageHeight(hPng)
  Dim pix(w, h)
  If hBmp <> #PB_Any
    FreeImage(hBmp)
  EndIf
  hBmp = CreateImage(#PB_Any, w, h, 32)
  StartDrawing(ImageOutput(hPng))
  DrawingMode(#PB_2DDrawing_AlphaChannel)
  Protected p, x, y, a
  For y = 0 To h - 1
    For x = 0 To w - 1
      p = Point(x, y)
      a = Alpha(p)
      pix(x, y) = RGBA(acol(a, Red(p)), acol(a, Green(p)), acol(a, Blue(p)), a)
    Next
  Next
  StopDrawing()
  x = 0
  y = h - 1
  StartDrawing(ImageOutput(hBmp))
  DrawingMode(#PB_2DDrawing_AlphaChannel)
  Protected *pixel.TArgb = DrawingBuffer()
  Protected *ends = *pixel + (w * h * 4) 
  While (*pixel < *ends)
    p = pix(x, y)
    *pixel\a = Alpha(p)
    *pixel\r = Red(p)
    *pixel\g = Green(p)
    *pixel\b = Blue(p)
    *pixel + 4
    x + 1
    If x >= w
      x = 0
      y - 1
    EndIf
  Wend
  StopDrawing()
  FreeArray(pix())
  If (newW <> #PB_Ignore)Or(newH <> #PB_Ignore)
    If newW = #PB_Ignore
      newW = w
    EndIf
    If newH = #PB_Ignore
      newH = h
    EndIf
    ResizeImage(hBmp, newW, newH, #PB_Image_Raw)
  EndIf
  ProcedureReturn hBmp
EndProcedure

;      
Procedure wndCreateChild(hParentWnd, hImage)
  ProcedureReturn OpenWindow(#PB_Any, 0, 0, ImageWidth(hImage), ImageHeight(hImage), "", #PB_Window_BorderLess|#WS_POPUP, WindowID(hParentWnd))
EndProcedure

;       
Procedure wndSkin(hWnd, hImage)
  ;    
  Protected hDC = StartDrawing(ImageOutput(hImage))
  DrawingMode(#PB_2DDrawing_AlphaChannel)
  Protected pt2.TPoint;    
  pt2\x = 0
  pt2\y = 0
  Protected sz.TPoint;    
  sz\x = ImageWidth(hImage)
  sz\y = ImageHeight(hImage)
  Protected bf.TBlendFunction; 
  bf\BlendOp = 0;#AC_SRC_OVER
  bf\BlendFlags = 0
  bf\SourceConstantAlpha = 255 ;   
  bf\AlphaFormat = 1;#AC_SRC_ALPHA;  -
  ;      
  SetWindowLong_(WindowID(hWnd), #GWL_EXSTYLE, GetWindowLong_(WindowID(hWnd), #GWL_EXSTYLE)|#WS_EX_LAYERED|#PB_Window_BorderLess|#WS_POPUP)
  ; 
  UpdateLayeredWindow_(WindowID(hWnd), 0, 0, @sz, hDC, @pt2, 0, @bf, 2);#ULW_ALPHA)
  StopDrawing()
  Delay(1)
EndProcedure

;   ,      
Procedure wndMoving(hWnd)
  If Moving
    GetCursorPos_(xy)
    ResizeWindow(hWnd, xy\x + dX, xy\y + dY, #PB_Ignore, #PB_Ignore)
    Moving = GetAsyncKeyState_(#VK_LBUTTON)
  EndIf
EndProcedure

;   
Procedure wndMoveOn(hWnd)
  Moving = #True
  GetCursorPos_(xy)
  dx = WindowX(hWnd) - xy\x
  dy = WindowY(hWnd) - xy\y
EndProcedure

;         -
;   
Global iAlpha
Global iColor
For iAlpha = 0 To 255
  For iColor = 0 To 255
    acol(iAlpha, iColor) = (iAlpha * iColor) >> 8
  Next
Next
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 46
; FirstLine = 32
; Folding = --
; EnableXP
; EnableOnError
; Executable = WndSkin.exe
; CompileSourceDirectory